/**
* The contents of this file are subject to the Mozilla Public 
* License Version 1.1 (the "License"); you may not use this 
* file except in compliance with the License. You may obtain a
* copy of the License at http://www.mozilla.org/MPL/
*
* Software distributed under the License is distributed on an 
* "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express 
* or implied. See the License for the specific language 
* governing rights and limitations under the License.
*
* The Original Code is this file as it was released on
* December 23, 2004.
*
* The Initial Developer of the Original Code is Terry Yuen. 
* Portions created by Terry Yuen are Copyright (C) 2004.
* All Rights Reserved.
**/

var hashColouredTabsCode = {
  hueTable : new Array(
    0xff0000, 0xff6600, 0xffcc00, 0xccff00, 0x66ff00, 
    0x00ff00, 0x00ff66, 0x00ffcc, 0x00ccff, 0x0066ff, 
    0x0000ff, 0x6600ff, 0xcc00ff, 0xff00cc, 0xff0066
  ),
  isActive: false,
  lt0: 42,
  lti: 30,
  ltn: 6,
  salt: 0,

  startup : function() {
    window.removeEventListener("load", hashColouredTabsCode.startup, false);
    hashColouredTabsCode.loadSettings();
    hashColouredTabsCode.addHooks();
    hashColouredTabsCode.checkStatus();
  },

  destroy : function() {
    window.removeEventListener("unload", hashColouredTabsCode.destroy, false);
    delete hashColouredTabsCode;
  },

  loadSettings : function() {
    hashColouredTabsCode.lt0 = gBrowser.mPrefs.getIntPref("hashcolouredtabs.light_base");
    hashColouredTabsCode.lti = gBrowser.mPrefs.getIntPref("hashcolouredtabs.light_inc");
    hashColouredTabsCode.ltn = gBrowser.mPrefs.getIntPref("hashcolouredtabs.light_count");
    hashColouredTabsCode.salt = gBrowser.mPrefs.getIntPref("hashcolouredtabs.salt");
    if(hashColouredTabsCode.salt == -1) {
      hashColouredTabsCode.salt = 50*(Math.round(Math.random()) + 1);
      gBrowser.mPrefs.setIntPref("hashcolouredtabs.salt", hashColouredTabsCode.salt);
    }
  },

  addHooks : function() {
    //get a copy of listeners created before our hooks (usually empty)
    var tmp = null;
    if(gBrowser.mTabListeners != null && gBrowser.mTabListeners.length > 0) {
      tmp = new Array();
      for(var i=0; i<gBrowser.mTabListeners.length; i++) {
        tmp.push(gBrowser.mTabListeners[i]);
      }
    }

    eval("gBrowser.mTabProgressListener =" + gBrowser.mTabProgressListener.toString().replace('return ({'
        ,'hashColouredTabsCode.checkStatus(1); aTab.addEventListener("error",function(){hashColouredTabsCode.addColour(aTab,aBrowser);},false); return ({')
      .replace('this.mTab.setAttribute("busy", "true");'
        ,'this.mTab.setAttribute("busy", "true"); hashColouredTabsCode.removeColour(this.mTab);')
      .replace('this.mTab.removeAttribute("busy");'
        ,'this.mTab.removeAttribute("busy"); hashColouredTabsCode.addColour(this.mTab, this.mBrowser);')
      .replace('(this.mTabBrowser.shouldLoadFavIcon(location)) {'
        ,'(this.mTabBrowser.shouldLoadFavIcon(location)) { hashColouredTabsCode.removeColour(this.mTab);')
      .replace('this.mTabBrowser.useDefaultIcon(this.mTab);'
        ,'{hashColouredTabsCode.removeColour(this.mTab); this.mTabBrowser.useDefaultIcon(this.mTab);}')
    );

    if(gBrowser.loadFavIcon)eval("gBrowser.loadFavIcon =" + gBrowser.loadFavIcon.toString().replace(/(aElt\.setAttribute\(aAttr, iconURL\);\s*\}?)/
      ,'$1 else hashColouredTabsCode.addColour(aElt,null,aURI);')
    );

    if(gBrowser.updateIcon)eval("gBrowser.updateIcon =" + gBrowser.updateIcon.toString().replace(/(aTab\.setAttribute\("image", browser\.mIconURL\);\s*\}?)/
        ,'hashColouredTabsCode.removeColour(aTab); $1')
      .replace(/(aTab\.removeAttribute\("image"\);\s*\}?)/
        ,'if(!aTab.hasAttribute("busy"))hashColouredTabsCode.addColour(aTab,browser); $1')
    );

    eval("gBrowser.removeTab =" + gBrowser.removeTab.toString().replace("this.updateCurrentBrowser();"
      ,'this.updateCurrentBrowser(); hashColouredTabsCode.checkStatus();')
    );

    if(tmp) {
      const _makeHandler = function(t, b) {
        return function() {hashColouredTabsCode.addColour(t, b);};
      };

      for(var i=0; i<tmp.length; i++) {
        tmp[i].mTab.addEventListener("error", _makeHandler(tmp[i].mTab,tmp[i].mBrowser), false);
        eval("tmp[i].onStateChange =" + tmp[i].onStateChange.toString().replace('this.mTab.setAttribute("busy", "true");'
            ,'this.mTab.setAttribute("busy", "true"); hashColouredTabsCode.removeColour(this.mTab);')
          .replace('this.mTab.removeAttribute("busy");'
            ,'this.mTab.removeAttribute("busy"); hashColouredTabsCode.addColour(this.mTab, this.mBrowser);')
          .replace('(this.mTabBrowser.shouldLoadFavIcon(location)) {'
            ,'(this.mTabBrowser.shouldLoadFavIcon(location)) { hashColouredTabsCode.removeColour(this.mTab);')
          .replace('this.mTabBrowser.useDefaultIcon(this.mTab);'
            ,'{hashColouredTabsCode.removeColour(this.mTab); this.mTabBrowser.useDefaultIcon(this.mTab);}')
        );
      }
      tmp = null;
    }

    //compatibility with Firefox 1.5, miniT and TabMix
    if(gBrowser.moveTabTo)eval("gBrowser.moveTabTo = " + gBrowser.moveTabTo.toString().replace(/(this\.mTabContainer\.insertBefore\(aTab, this\.mTab[^\[]+\[aIndex\]\))/
      ,"var hcttmp=($1); if(!hcttmp.hasAttribute('busy')&&!hcttmp.hasAttribute('image'))hashColouredTabsCode.addColour(hcttmp,gBrowser.getBrowserForTab(hcttmp));")
    );

    if(typeof tablib == "object")eval("tablib.init = " + tablib.init.toString().replace(/(this\.mTabContainer\.insertBefore\(aTab, this\.mTab[^\[]+\[aIndex\]\))/
      ,"var hcttmp=($1); if(!hcttmp.hasAttribute('busy')&&!hcttmp.hasAttribute('image'))hashColouredTabsCode.addColour(hcttmp,gBrowser.getBrowserForTab(hcttmp));")
    );
  },

  checkStatus : function(delta) {
    var min = gBrowser.mPrefs.getIntPref("hashcolouredtabs.tab_count_trigger");
    if(min < 0)return;  //if < 0, then trigger is disabled

    var cur = gBrowser.mTabListeners.length;
    if(delta)cur += delta;

    if(cur >= min) {
      if(!hashColouredTabsCode.isActive) {
        hashColouredTabsCode.isActive = true;
        gBrowser.setAttribute("hashedtabs", true);
        hashColouredTabsCode.refreshAllTabs();
      }
    } else {
      if(hashColouredTabsCode.isActive) {
        hashColouredTabsCode.isActive = false;
        gBrowser.removeAttribute("hashedtabs");
        hashColouredTabsCode.refreshAllTabs();
      }
    }
  },

  refreshAllTabs : function() {
    var arr = gBrowser.mTabListeners;
    var len = arr.length;
    if(hashColouredTabsCode.isActive) {
      for(var i=0; i<len; i++) {
        if(!arr[i].mTab.hasAttribute("busy") && !arr[i].mTab.hasAttribute("image"))
          hashColouredTabsCode.addColour(arr[i].mTab, arr[i].mBrowser);
      }
    } else {
      hashColouredTabsCode.isActive = true;
      for(var i=0; i<len; i++)hashColouredTabsCode.removeColour(arr[i].mTab);
      hashColouredTabsCode.isActive = false;
    }
  },

  removeColour : function(t) {
    if(!hashColouredTabsCode.isActive)return;
    document.getAnonymousElementByAttribute(t,"class","tab-icon").style.backgroundColor = "transparent";
  },

  addColour : function(t, b, u) {
    if(!hashColouredTabsCode.isActive)return;

    var host = null;
    try {
      if(b)host = b.webNavigation.currentURI.host;
      else host = u.host;
      if(host.length == 0)throw "host = empty string";
    } catch(e) {
      try {
        if(b)host = b.webNavigation.currentURI.scheme;
        else host = u.scheme;
      } catch(e2) {
        hashColouredTabsCode.removeColour(t);
        return;
      }
    }

    document.getAnonymousElementByAttribute(t,"class","tab-icon").style.backgroundColor = hashColouredTabsCode.getHashColorForTab(host);
  },

  getHashColorForTab : function(str) {
    //very simple algorithm to calculate the hash
    var hash = hashColouredTabsCode.salt;
    for(var i=0,len=str.length; i<len; i++) {
      hash += str.charCodeAt(i)*(i + 1);
    }
    hash %= 15*hashColouredTabsCode.ltn;

    var tmp = hashColouredTabsCode.hueTable[Math.floor(hash/hashColouredTabsCode.ltn)];
    var r = (tmp & 0xff0000) >> 16;
    var g = (tmp & 0x00ff00) >> 8;
    var b = (tmp & 0x0000ff) >> 0;

    //now calculate the lightness. min=lt0, max=min+(ltn*lti)
    tmp = hashColouredTabsCode.lt0 + hashColouredTabsCode.lti*(hash % hashColouredTabsCode.ltn) - 128;
    if(tmp < 0) {  //increase lightness
      tmp /= -128.0;
      r = Math.min(Math.round(r + tmp*(255 - r)), 255);
      g = Math.min(Math.round(g + tmp*(255 - g)), 255);
      b = Math.min(Math.round(b + tmp*(255 - b)), 255);
    }
    else if(tmp > 0) {  //decrease lightness
      tmp = (128 - tmp) / 128.0;
      r = Math.max(Math.round(tmp*r), 0);
      g = Math.max(Math.round(tmp*g), 0);
      b = Math.max(Math.round(tmp*b), 0);
    }

    return "rgb("+r+","+g+","+b+")";
  }
};

window.addEventListener("load", hashColouredTabsCode.startup, false);
window.addEventListener("unload", hashColouredTabsCode.destroy, false);